#!/bin/bash

#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.2
#Date:          10-03-07 / 11-10-07
#System:        Xubuntu 7.10
#Information:   man convert
#Category       Thunar scripts (thunar->edit->custom actions)
#Name:          Convert Image
#Description:   Create special new image(s)
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute ~/.scripts/thunar/convert-image.sh %F
#Patterns:      *
#Image Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo "$2" "$3"
    tput sgr0
}

echo "Process these file(s):"
for I in "$@"
do
    file=${I##*/}
    cecho "cyan" "$file"
done

echo -n "are you sure you want to continue [Y/n]? "
read input
if [ "$input" = "n" ]
then
    exit 0
fi

cecho "green" "choose a option and press enter"
cecho "red" "[1] 640x480"
cecho "red" "[2] 800x600"
cecho "red" "[3] 1024x768"
cecho "red" "[4] back and white"
cecho "red" "[5] increase with 20%"
cecho "red" "[6] decrease with 20%"
cecho "red" "[7] process for documentation"
cecho "red" "[8] two images to one"
cecho "red" "[9] four images to one"
cecho "red" "[10] nine images to one"
cecho "red" "[11] sixteen images to one"
read option

#whereis convert
if [ ! -e /usr/bin/convert ]
then
    cecho "red" "imagemagick toolkit not found, installing now"
    sudo apt-get install imagemagick
fi

echo "enter current working directory: "
cecho "blue" "$PWD"
cd "$PWD"

for I in "$@"
do
    cecho "green" "starting with: "

    dirname=${I%/*}
    file=${I##*/}
    filename=${I##*/}; filename=${filename%.*}
    extension=${I##*.}

    #echo "$dirname"
    #echo "$file"
    #echo "$filename"
    #echo "$extension"

    #if [[ $I = *.* ]]; then [[ $I = *.tar.gz ]] && ext=tar.gz || ext=${I##*.}; else unset ext; fi; file=${I%${ext+.$ext}} file=${file##*/} dir=${I%$file${ext+.$ext}}
    #[ $I = *.tar.* ]] && x=${I%.tar.*} ext=${I##$x.} || else unset ...
    #... fi; ext=${ext+.$ext} file=${I%$ext} file=${file##*/} dir=${I%$file$ext}

    if [ ! -O "$I" ]
    then
        permission="sudo"
    fi

    if [ "$option" = "1" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -resize 640x480 -verbose "640x480-$filename.$extension"
    fi

    if [ "$option" = "2" ]
    then
        echo "staring convert command, please standby"
        $permission  convert "$file" -quality 100 -resize 800x600 -verbose "800x600-$filename.$extension"
    fi

    if [ "$option" = "3" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -resize 1024x768 -verbose "1024x768-$filename.$extension"
    fi

    if [ "$option" = "4" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -type Grayscale -verbose "grayscale-$filename.$extension"
    fi

    if [ "$option" = "5" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -resize 120%x120% -verbose "increase-$filename.$extension"
    fi

    if [ "$option" = "6" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -resize 80% -verbose "decrease-$filename.$extension"
    fi

    if [ "$option" = "7" ]
    then
        echo "staring convert command, please standby"
        $permission convert "$file" -quality 100 -resize '640x480>' -verbose "documentation-$filename.$extension"
    fi

    if [ "$option" = "8" ] || [ "$option" = "9" ] || [ "$option" = "10" ] || [ "$option" = "11" ]
    then
    	#$permission montage -background none -border 0 -tile 2x2 "${image_query[@]}" -quality 100 -verbose "4in1-image.jpg"
        #$permission montage -tile 2x2  "$file" -quality 100 -verbose "4in1-$filename.$extension"
        #convert 1.png 2.png +append \( 3.png 4.png +append \) -append out.png
        #http://www.imagemagick.org/Usage/layers/#append
        echo "adding $filename to image query"
        image_query+=("$file")
    fi

    cecho "green" "completed"
    cecho "blue" "---------------"
done

if [ -n "$image_query" ]
then
    if [ "$option" = "8" ]
    then
        echo "staring convert command, please standby"
        $permission convert -quality 100 -verbose "${image_query[0]}" +append \( "${image_query[1]}" +append \) -append 2in1-image.jpg
    fi

    if [ "$option" = "9" ]
    then
        echo "staring convert command, please standby"
		$permission convert -quality 100 -verbose "${image_query[0]}" "${image_query[1]}" +append \( "${image_query[2]}" "${image_query[3]}" +append \) -append 4in1-image.jpg
    fi

    if [ "$option" = "10" ]
    then
        echo "staring convert command, please standby"
        $permission convert -quality 100 -verbose "${image_query[0]}" "${image_query[1]}" "${image_query[2]}" +append \( "${image_query[3]}" "${image_query[4]}" "${image_query[5]}" +append \) -append +append \( "${image_query[6]}" "${image_query[7]}" "${image_query[8]}" +append \) -append 9in1-image.jpg
    fi

    if [ "$option" = "11" ]
    then
        echo "staring convert command, please standby"
        $permission convert -quality 100 -verbose "${image_query[0]}" "${image_query[1]}" "${image_query[2]}" "${image_query[3]}" +append \( "${image_query[4]}" "${image_query[5]}" "${image_query[6]}" "${image_query[7]}" +append \) -append +append \( "${image_query[8]}" "${image_query[9]}" "${image_query[10]}" "${image_query[11]}" +append \) -append +append \( "${image_query[12]}" "${image_query[13]}" "${image_query[14]}" "${image_query[15]}" +append \) -append 16in1-image.jpg
    fi
fi

echo -n "everything completed, are you sure you want to exit [Y/n]? "
read input
if [ "$input" = "n" ]
then
    exit 0
fi

exit 0

##!/bin/bash
#for I
#do
        #if [[ $I = *.* ]]
        #then [[ $I = *.tar.gz ]] && ext=tar.gz || ext=${I##*.}
        #else unset ext
        #fi
        #ext=${ext+.$ext}
        #file=${I%$ext} file=${file##*/}
        #dir=${I%$file$ext}

        #echo $I
        #[[ $I = "$dir$file$ext" ]] || echo "oops: $I != $dir$file$ext"
        #echo dir=$dir file=$file ext=$ext
        #echo
#done
