#!/bin/bash

#Company:       PowerCraft Technology
#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.3
#Date:          28-11-06 / 10-02-07
#System:        Xubuntu 7.10
#Information:   man zip
#Category       Thunar scripts (thunar->edit->custom actions)
#Name:          Create Archive
#Description:   Create a archive with from selected file(s)
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute ~/.scripts/thunar/create-archive.sh %F
#Patterns:      *
#Directories:   True
#Audio Files:   True
#Image Files:   True
#Text Files:    True
#Video Files:   True
#Other Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo $2 $3
    tput sgr0
}

echo "processing file(s):"
for I in "$@"
do
    cecho "blue" "$I"
done

echo "enter current working directory: "
cecho "blue" "$PWD"
cd "$PWD"

echo -n "are you sure you want to continue [Y/n]? "
read input
if [ "$input" = "n" ]
then
    exit 0
fi

for I in "$@"
do
    dirname=${I%/*}
    file=${I##*/}
    filename=${I##*/}; filename=${filename%.*}
    extension=${I##*.}

    cecho "green" "starting with: "
    echo "$file"

    query+=("$file")

    cecho "green" "completed with: "
    echo "$file"
    cecho "blue" "---------------"
done

if [ -n "$query" ]
then
    cecho "blue" "creating archive: $filename.zip"
    cecho "blue" "command: zip -r -T $filename.zip ${query[@]}"
    #~ zip -r -T "$filename".zip "${query[@]}"
    tar --create --verbose --gzip --file "$filename".tar.gz "${query[@]}"
fi

cecho "green" "done, closing after 30 seconds"
sleep 30

exit 0
