#!/bin/bash

#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.1
#Date:          28-06-2007
#System:        xubuntu 7.10
#Information:   man mpg123 ogg123 flac123
#Category       Thunar scripts (thunar->edit->custom actions)
#Name:          Mediaplayer preprocessor
#Description:   Recursively rename all files for mediaplayer device
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute ~/.scripts/thunar/directory-mediaplayer-preprocessor.sh %F
#Patterns:      *
#Directories:   True
#Audio Files:   True
#Other Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo "$2" "$3"
    tput sgr0
}

process_file()
{
    file="$1"
    dirname=${file%/*}; dirname=${dirname##*/}
    filename=${file##*/}; filename=${filename%.*}
    extension=${file##*.}
    
    echo "pwd: $PWD"
    echo "file: $file"
    echo "dirname: $dirname"
    echo "filename: $filename"
    echo "extension: $extension"
    echo "new: Mediaplayer/$dirname-$filename.$extension"
    echo "----------"
    
    [[ ! -d "Mediaplayer" ]] && mkdir "Mediaplayer"
    cp "$file" "Mediaplayer/$dirname-$filename.$extension"
}

scan_directory()
{
    for file in "$1"/*
    do
        if [ -f "$file" ]
        then
            process_file "$file"
        fi
        
        if [ -d "$file" ]
        then
            scan_directory "$file"
        fi    
    done
}

cecho "green" "processing:"
for I in "$@" 
do
    filename=${I##*/}
    cecho "blue" "$filename"
done

cecho "blue" "---------------"

for I in "$@" 
do
    cecho "green" "starting: "

    if [ -f "$I" ]
    then
        process_file "$I"
    fi

    if [ -d "$I" ]
    then
        scan_directory "$I"
    fi

    cecho "green" "completed:"
    cecho "blue" "---------------"
done

cecho "green" "done, closing after 3 seconds"

sleep 3

exit
