#!/bin/bash

#Company:       PowerCraft Technology
#Author:        Copyright Jelle de Jong <jelledejong@powercraft.nl>
#Note:          Please send me an email if you enhanced this script
#Version:       0.0.3
#Date:          30-07-2006 / 17-08-2006 / 24-01-2008
#System:        Xubuntu 7.10
#Information:   man rm, man sudo
#Category       Thunar scripts
#Name:          Remove
#Description:   Recursively remove a directory
#Command:       xfce4-terminal --disable-server --hide-toolbars --execute ~/.scripts/thunar/directory-remove.sh %F
#Patterns:      *
#Directories:   True
#Audio Files:   True
#Image Files:   True
#Text Files:    True
#Video Files:   True
#Other Files:   True

# Did the script work for you?
# Yes
# Yes, but with some errors
# Yes, but I had to change some things
# Not at all

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
# MA 02110-1301, USA.

cecho()
{
    if [ "$1" = "black" ]; then
        echo -ne "\E[30m"
    elif [ "$1" = "red" ]; then
        echo -ne "\E[31m"
    elif [ "$1" = "green" ]; then
        echo -ne "\E[32m"
    elif [ "$1" = "yellow" ]; then
        echo -ne "\E[33m"
    elif [ "$1" = "blue" ]; then
        echo -ne "\E[34m"
    elif [ "$1" = "magenta" ]; then
        echo -ne "\E[35m"
    elif [ "$1" = "cyan" ]; then
        echo -ne "\E[36m"
    fi

    echo $2 $3
    tput sgr0
}

echo "recursively remove these directory(s) or file(s):"
for I in "$@" 
do
    cecho "blue" "$I"
done

echo -n "are you sure you want to continue [Y/n]? "
read input
if [ "$input" = "n" ]
then
    exit 0
fi

for I in "$@" 
do
    cecho "blue" "starting with: "
    echo "$I"

    if [ -w "$I" ]
    then
        rm --recursive --force "$I"
    else
        sudo rm --recursive --force "$I"
    fi

    if [ $? -eq 1 ]
    then
        cecho "red" "retry with superuser rights"

        sudo rm --recursive --force "$I"

        if [ $? -eq 1 ]
        then
            cecho "red" "error, exit in 30 seconds without success"
            sleep 30
            exit 1
        fi
    fi

    cecho "green" "completed"
    cecho "blue" "---------------"
done

echo "done, closing after 3 seconds"
sleep 3

exit 0
